; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Object - V0.0.1
; Nom du projet : Le nom du projet ici
; Nom du fichier : Nom du fichier
; Version du fichier : 0.0.0
; Programmation :  vrifier
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 16-05-2019
; Mise  jour : 16-05-2019
; Cod pour PureBasic : V5.71 beta 1 LTS
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Game

  Interface Game
    
    GetMode()
    GetOnline()
    ToggleMode()
    ToggleOnline()
    CreateGadgets()
    UpdateChronoGadget()
    UpdateScoreGadget()
    GetStartButtonHandle()
    GetToggleModeButtonHandle()
    GetShowScoreButtonHandle()
    GetToggleOnlineButtonHandle()
    RefreshShape()
    RandomizeShape()
    Update(OneShot.b = #False)
    CountDownManager()
    MoveShapeX(P_Direction.b)
    MoveShapeY(P_Direction.b, *Language.Language::Language)
    RotateShape(P_Direction.b)
    StartNewGame()
    SaveScoreFile()
    ShowScoreTables(*Language.Language::Language)
    ReadPrefs(GroupName.s)
    WritePrefs(GroupName.s)
    Free()

  EndInterface

  Declare.i New(P_UserPath.s)

EndDeclareModule

Module Game
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Constantes de dimensionnement <<<<<
  
  Enumeration
    
    #GAME_BLOCK_DUMMY
    #GAME_BLOCK_GREEN
    #GAME_BLOCK_RED
    #GAME_BLOCK_BLUE
    #GAME_BLOCK_ORANGE
    #GAME_BLOCK_YELLOW
    #GAME_BLOCK_PURPLE
    #GAME_BLOCK_GRAY  
    #GAME_BLOCK_MAGENTA
    
    #GAME_BLOCK_MAX
    
  EndEnumeration
  
  #GAME_BLOCK_SIZE = 30
  #GAME_BLOCK_ROUDING_RADIUS = 10
  
  Structure Private_Members
    
    VirtualTable.i
    ScoreFileName.s
    Mode.b
    Online.b
    Lost.b
    CurrentShape.l
    ComingShape.l
    ShapeX.l
    ShapeY.l
    ShapeR.l ; Special : Looping
    IsCountDownActive.b ; Special : Toggle
    CountDownValue.b    ; Special : Decrement
    Score.Score::Score
    Player.Player::Player
    Chrono.Chrono::Chrono
    ScoreWindow.Window::Window
    Array Shape.q(#GAME_BLOCK_MAX-1, 4)
    Array Area.b(9, 16)
    BlockImage.i[#GAME_BLOCK_MAX]
    BackArea.i
    BackFuture.i
    AreaGadget.i
    PreviewGadget.i
    ChronoGadget.i
    ScoreGadget.i
    StartGadget.i
    ModeGadget.i
    ShowScoreGadget.i
    OnlineGadget.i
    
  EndStructure
  
  Macro LinearlySpacedValue(IncrementID, IncrementMax, MinValue, MaxValue)
    
     ((MinValue) + ((MaxValue) - (MinValue)) * ((IncrementID) / (IncrementMax)))
  
  EndMacro
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< BlockGameFuture() <<<<<
  
  Procedure BlockFuture(*This.Private_Members, OneShot.b = #False)
    
    If *This\BackFuture = 0 
      *This\BackFuture = CreateImage(#PB_Any, #GAME_BLOCK_SIZE*6+32, #GAME_BLOCK_SIZE*6)
    EndIf
    
    If IsImage(*This\BackFuture)
      
      If StartDrawing(ImageOutput(*This\BackFuture))
        
        Box(0, 0, #GAME_BLOCK_SIZE*6+32, #GAME_BLOCK_SIZE*6, 0)
        
        If OneShot = #False
          
          iPos = %1000000000000000
          iForme = *This\Shape(*This\ComingShape, 1)
          
          For y = 0 To 3
            
            For x = 0 To 3
              
              If (iForme & iPos) > 0
                DrawImage(ImageID(*This\BlockImage[*This\ComingShape]), x*#GAME_BLOCK_SIZE + 60, y*#GAME_BLOCK_SIZE+40)
              EndIf
              
              iPos >> 1
              
            Next
            
          Next
          
        EndIf  
        
      EndIf
      
      StopDrawing()
      
    EndIf
    
  EndProcedure
  
  Procedure BlockArea(*This.Private_Members, OneShot.b = #False)
    
    If *This\BackArea = 0
      *This\BackArea = CreateImage(#PB_Any, #GAME_BLOCK_SIZE*10, #GAME_BLOCK_SIZE*17)
    EndIf
    
    If IsImage(*This\BackArea)
      
      If StartDrawing(ImageOutput(*This\BackArea))
        
        Box(0, 0, #GAME_BLOCK_SIZE*10, #GAME_BLOCK_SIZE*17, 0)
        
        If OneShot = #False
          
          iPos = %1000000000000000      
          iForme = *This\Shape(*This\CurrentShape, *This\ShapeR)
          
          For y = 0 To 3
            For x = 0 To 3
              If (iForme & iPos) > 0
                DrawImage(ImageID(*This\BlockImage[*This\CurrentShape]), x * #GAME_BLOCK_SIZE + *This\ShapeX * #GAME_BLOCK_SIZE, y * #GAME_BLOCK_SIZE + *This\ShapeY * #GAME_BLOCK_SIZE)
              EndIf
              iPos >> 1
            Next
          Next
          
          For y = 0 To 16
            For x = 0 To 9
              If *This\Area(x, y) > 0
                DrawImage(ImageID(*This\BlockImage[*This\Area(x, y)]), x * #GAME_BLOCK_SIZE , y * #GAME_BLOCK_SIZE)
              EndIf
            Next
          Next
          
        EndIf
        
        If OneShot = -1
          
          For y = 0 To 16
            For x = 0 To 9
              If *This\Area(x, y) > 0
                DrawImage(ImageID(*This\BlockImage[*This\Area(x, y)]), x * #GAME_BLOCK_SIZE , y * #GAME_BLOCK_SIZE)
              EndIf
            Next
          Next
          
        EndIf
        
        StopDrawing()
        
      EndIf
      
    EndIf
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< BlockImage() <<<<<
  
  Procedure BlockImage(Color)
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ; This command will draw a square block with
    ; a pillow effect on all edges.
    
    ImageID = CreateImage(#PB_Any, #GAME_BLOCK_SIZE, #GAME_BLOCK_SIZE)
    
    If IsImage(ImageID)
      
      If StartDrawing(ImageOutput(ImageID))
        
        For Size = 0 To #GAME_BLOCK_ROUDING_RADIUS
          Box(0 + Size, 0 + Size, #GAME_BLOCK_SIZE - 2 * Size, #GAME_BLOCK_SIZE - 2 * Size, ColorEffex::Luminosity(Color, Sin(Radian(LinearlySpacedValue(Size, #GAME_BLOCK_ROUDING_RADIUS, 30.0, 90.0)))))
        Next
        
        StopDrawing()
        
      EndIf
      
    EndIf
    
    ProcedureReturn ImageID
  EndProcedure
  
  Procedure GetMode(*This.Private_Members)
  
    ProcedureReturn *This\Mode
  EndProcedure
  
  Procedure GetOnline(*This.Private_Members)
  
    ProcedureReturn *This\Online
  EndProcedure
  
  Procedure ToggleMode(*This.Private_Members)

    *This\Mode = *This\Mode ! 1

  EndProcedure
  
  Procedure ToggleOnline(*This.Private_Members)

    *This\Online = *This\Online ! 1

  EndProcedure
  
  
  Procedure CreateGadgets(*This.Private_Members)
    
    *This\AreaGadget = ImageGadget(#PB_Any, 5, 5, #GAME_BLOCK_SIZE*10, #GAME_BLOCK_SIZE*17, ImageID(*This\BackArea), #PB_Image_Border)
    *This\PreviewGadget = ImageGadget(#PB_Any, #GAME_BLOCK_SIZE*10 + 10, 5, #GAME_BLOCK_SIZE*6+32, #GAME_BLOCK_SIZE*6, ImageID(*This\BackFuture), #PB_Image_Border)
    *This\ChronoGadget = Counter::Gadget(#PB_Any, #GAME_BLOCK_SIZE*10 + 10, #GAME_BLOCK_SIZE*6+10,"88:88:88", 3, RGB(000, 255, 000), RGB(000, 48, 000), 0, 1)
    *This\ScoreGadget = Counter::Gadget(#PB_Any, #GAME_BLOCK_SIZE*10 + 10, GadgetY(*This\ChronoGadget) + GadgetHeight(*This\ChronoGadget) + 5, "::888888", 3, RGB(000, 255, 000), RGB(000, 48, 000), 0, 1)
    *This\StartGadget = ButtonGadget(#PB_Any, #GAME_BLOCK_SIZE*10 + 10, GadgetY(*This\ScoreGadget) + GadgetHeight(*This\ScoreGadget) + 5, GadgetWidth(*This\ScoreGadget), 34, "")
    *This\ModeGadget = ButtonGadget(#PB_Any, #GAME_BLOCK_SIZE*10 + 10, GadgetY(*This\StartGadget) + GadgetHeight(*This\StartGadget) + 5, GadgetWidth(*This\StartGadget), 34, "")
    *This\ShowScoreGadget = ButtonGadget(#PB_Any, #GAME_BLOCK_SIZE*10 + 10, GadgetY(*This\ModeGadget) + GadgetHeight(*This\ModeGadget) + 5, GadgetWidth(*This\ModeGadget), 34, "")
    *This\OnlineGadget = ButtonGadget(#PB_Any, #GAME_BLOCK_SIZE*10 + 10, GadgetY(*This\ShowScoreGadget) + GadgetHeight(*This\ShowScoreGadget) + 5, GadgetWidth(*This\ShowScoreGadget), 34, "")
    
  EndProcedure
  
  Procedure UpdateChronoGadget(*This.Private_Members)
  
    MilliSeconds.q = *This\Chrono\Consult()
    
    Days = MilliSeconds / 86400000 
    MilliSeconds % 86400000
    
    Hours = MilliSeconds / 3600000
    MilliSeconds % 3600000
    
    Minutes = MilliSeconds / 60000
    MilliSeconds % 60000
    
    Seconds = MilliSeconds / 1000
    MilliSeconds % 1000
    
    If Second % 2 = 0
      Counter::SetValue(*This\ChronoGadget, *This\Chrono\Format("%hh:%mm:%ss"))
    Else
      Counter::SetValue(*This\ChronoGadget, *This\Chrono\Format("%hh|%mm|%ss"))
    EndIf
    
  EndProcedure
  
  Procedure UpdateScoreGadget(*This.Private_Members)
    
    Counter::SetValue(*This\ScoreGadget, "||" + RSet(Str(*This\Player\GetPoints()), 6, "0"))

  EndProcedure
  
  Procedure GetStartButtonHandle(*This.Private_Members)
  
    ProcedureReturn *This\StartGadget
  EndProcedure
  
  Procedure GetToggleModeButtonHandle(*This.Private_Members)
  
    ProcedureReturn *This\ModeGadget
  EndProcedure
  
  Procedure GetShowScoreButtonHandle(*This.Private_Members)
    
    ProcedureReturn *This\ShowScoreGadget
  EndProcedure
  
  Procedure GetToggleOnlineButtonHandle(*This.Private_Members)
    
    ProcedureReturn *This\OnlineGadget
  EndProcedure
  
  Procedure RefreshShape(*This.Private_Members)
    
    *This\ShapeX = 3
    *This\ShapeY = 0
    *This\ShapeR = 1
    
  EndProcedure
  
  Procedure RandomizeShape(*This.Private_Members)
    
    If *This\ComingShape = 0 And *This\CurrentShape = 0
      *This\CurrentShape = Random(#GAME_BLOCK_MAX - 2) + 1
      *This\ComingShape = Random(#GAME_BLOCK_MAX - 2) + 1
    Else
      *This\CurrentShape = *This\ComingShape
      *This\ComingShape = Random(#GAME_BLOCK_MAX - 2) + 1
    EndIf
    
    While *This\CurrentShape = *This\ComingShape
      *This\ComingShape = Random(#GAME_BLOCK_MAX - 2) + 1
    Wend
    
  EndProcedure
  
  Procedure Update(*This.Private_Members, OneShot.b = #False)
    
    BlockArea(*This, OneShot)
    BlockFuture(*This, OneShot)
    
    If OneShot = #False
      SetGadgetState(*This\PreviewGadget, ImageID(*This\BackFuture))
      SetGadgetState(*This\AreaGadget, ImageID(*This\BackArea))
    EndIf

  EndProcedure
 
  Procedure CountDownManager(*This.Private_Members)
    
    If *This\IsCountDownActive
      
      Select *This\CountDownValue
          
        Case 5
          Restore Number5
          
        Case 4
          Restore Number4
          
        Case 3
          Restore Number3
          
        Case 2
          Restore Number2
          
        Case 1
          Restore Number1
          
        Case 0
          Restore Number0
          
      EndSelect
      
      If *This\CountDownValue >= 0
        
        Color = Random(#GAME_BLOCK_MAX - 2) + 1
        
        For y = 0 To 16
          
          For x = 0 To 9
            Read.b *This\Area(x, y)
            *This\Area(x, y) = *This\Area(x, y) * Color
          Next
          
        Next
        
        *This\CountDownValue - 1
        BlockArea(*This, -1)
        SetGadgetState(*This\AreaGadget, ImageID(*This\BackArea))
        
      Else
        
        For y = 0 To 16
          For x = 0 To 9
            *This\Area(x, y) = 0
          Next
        Next
        
        *This\IsCountDownActive = #False
        *This\Lost = #False
        *This\CountDownValue = 5
        *This\Chrono\Start()
        Update(*This)
        
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure.b Private_Collision(*This.Private_Members)
    
    iPos = %1000000000000000
    iForme = *This\Shape(*This\CurrentShape, *This\ShapeR)
    
    For y = 0 To 3
      
      For x = 0 To 3
        
        If ((*This\ShapeX + x) > 9 Or (*This\ShapeX + x) < 0) And (iForme & iPos) > 0
          ProcedureReturn 1
        ElseIf (*This\ShapeY + y) > 16 And (iForme & iPos) > 0
          ProcedureReturn 1
        ElseIf (iForme & iPos) > 0 And *This\Area(*This\ShapeX + x, *This\ShapeY + y) > 0
          ProcedureReturn 1
        EndIf
        
        iPos >> 1
        
      Next
      
    Next
    
    ProcedureReturn 0
  EndProcedure
  
  Procedure Private_Memorize(*This.Private_Members, *Language.Language::Language)
    
    iPos = %1000000000000000
    iForme = *This\Shape(*This\CurrentShape, *This\ShapeR)
    
    For y = 0 To 3
      For x = 0 To 3
        If (iForme & iPos) > 0
          *This\Area(*This\ShapeX + x, *This\ShapeY + y) = *This\CurrentShape
        EndIf
        iPos >> 1
      Next
    Next
    
    NbLigne = 0
    
    For y = 0 To 16
      
      Ligne = 0
      
      For x = 0 To 9
        If *This\Area(x, y) > 0
          Ligne + 1
        EndIf
      Next
      
      If Ligne = 10
        
        For xx = 0 To 9
          
          For yy = y To 1 Step - 1
            *This\Area(xx, yy) = *This\Area(xx, yy - 1)
          Next
          
          *This\Area(xx, 0) = 0
          
        Next
        
        NbLigne + 1
        
        *This\Player\IncrementCompletedLine()
        *This\Player\AddPoints(5 + NbLigne * 5)

      EndIf
      
    Next

    Select *This\Online
        
      Case 0
        
        If *This\Player\GetPoints() >= 500 And *This\Mode = 0
          
          *This\Chrono\Stop()
          *This\Player\SetTotalTime(*This\Chrono\Consult())
          *This\Lost = 2
          UpdateScoreGadget(*This)
          
          Position = *This\Score\InsertQualifiedOfflinePlayerScore(*This\Player, *This\Mode)
          
          If Position <> -1
            MessageRequester(*Language\Message("Good news"), *Language\Message("Your score is qualified for the position : ") + Str(Position + 1))
          EndIf
          
        EndIf
        
        If *This\Player\GetPoints() >= 1500 And *This\Mode = 1
          
          *This\Chrono\Stop()
          *This\Player\SetTotalTime(*This\Chrono\Consult())
          *This\Lost = 2
          UpdateScoreGadget(*This)
          
          Position = *This\Score\InsertQualifiedOfflinePlayerScore(*This\Player, *This\Mode)
          
          If Position <> -1
            MessageRequester(*Language\Message("Good news"), *Language\Message("Your score is qualified for the position : ") + Str(Position + 1))
          EndIf
          
        EndIf  
        
      Case 1
        
        If *This\Player\GetPoints() >= 500 And *This\Mode = 0
          
          *This\Chrono\Stop()
          *This\Player\SetTotalTime(*This\Chrono\Consult())
          *This\Lost = 2
          UpdateScoreGadget(*This)
          
          *This\Score\ExamineOnlineScore()
          
          Position = *This\Score\InsertQualifiedOnlinePlayerScore(*This\Player, *This\Mode)
          
          If Position <> -1
            
            PlayerName.s = InputRequester(*Language\Message("Good news"), *Language\Message("Your score is qualified for the position : ") + Str(Position + 1) + Chr(10) + *Language\Message("Please enter your name :"), *This\Player\GetName())
            
            If PlayerName <> ""
              *This\Player\SetName(PlayerName)
              *This\Score\AddOnlineScoreItem(*This\Player, *This\Mode)
            EndIf
            
          EndIf
          
        EndIf
        
        If *This\Player\GetPoints() >= 1500 And *This\Mode = 1
          
          *This\Chrono\Stop()
          *This\Player\SetTotalTime(*This\Chrono\Consult())
          *This\Lost = 2
          UpdateScoreGadget(*This)
          *This\Score\ExamineOnlineScore()
          Position = *This\Score\InsertQualifiedOnlinePlayerScore(*This\Player, *This\Mode)
          
          If Position <> -1
            
            PlayerName.s = InputRequester(*Language\Message("Good news"), *Language\Message("Your score is qualified for the position : ") + Str(Position + 1) + Chr(10) + *Language\Message("Please enter your name :"), *This\Player\GetName())
            
            If PlayerName <> ""
              *This\Player\SetName(PlayerName)
              *This\Score\AddOnlineScoreItem(*This\Player, *This\Mode)
            EndIf
            
          EndIf
          
        EndIf     
        
    EndSelect
    
    If *This\Lost = #False
      
      UpdateScoreGadget(*This)
      RandomizeShape(*This)
      RefreshShape(*This)
      
      If Private_Collision(*This)
        *This\Lost = #True
        *This\Chrono\Stop()
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure MoveShapeX(*This.Private_Members, P_Direction.b)
    
    If *This\Lost = #False
      
      *This\ShapeX + P_Direction
      
      If Private_Collision(*This) = 1
        *This\ShapeX + (-1 * P_Direction)
      EndIf
      
      Update(*This)
      
    EndIf 
    
  EndProcedure
  
  Procedure MoveShapeY(*This.Private_Members, P_Direction.b, *Language.Language::Language)
    
    If *This\Lost = #False
      
      *This\ShapeY + P_Direction
      
      If Private_Collision(*This) >= 1
        *This\ShapeY + (-1 * P_Direction)
        Private_Memorize(*This, *Language)
      EndIf
      
      Update(*This)
      
    EndIf
    
  EndProcedure
  
  Procedure Private_LoopingShapeR(*This.Private_Members, P_Minimum.l, P_Maximum.l, P_Increment.l)

    *This\ShapeR = *This\ShapeR + P_Increment

    If *This\ShapeR > P_Maximum
      *This\ShapeR = P_Minimum
    ElseIf *This\ShapeR < P_Minimum
      *This\ShapeR = P_Maximum
    EndIf

  EndProcedure
  
  Procedure RotateShape(*This.Private_Members, P_Direction.b)
    
    If *This\Lost = #False
      
      Private_LoopingShapeR(*This, 1, 4, P_Direction)
      
      If Private_Collision(*This) = #True
        Private_LoopingShapeR(*This, 1, 4, (-1*P_Direction))
      EndIf
      
      Update(*This)
      
    EndIf
    
  EndProcedure
  
  Procedure Refresh(*This.Private_Members)
    
    RandomizeShape(*This)
    RandomizeShape(*This) 
    RefreshShape(*This)
    
    For Area_ID_2 = 0 To ArraySize(*This\Area(), 2)
      For Area_ID_1 = 0 To ArraySize(*This\Area(), 1)
        *This\Area(Area_ID_1, Area_ID_2) = 0
      Next
    Next
    
    *This\Player\Refresh()
    *This\Chrono\Reset()
    *This\Lost = #True
    *This\IsCountDownActive = 0
    *This\CountDownValue = 5
     UpdateScoreGadget(*This)
     Update(*This, #True)
    
  EndProcedure
 
  Procedure StartNewGame(*This.Private_Members)
    
    If *This\IsCountDownActive = #False
      Refresh(*This)
      Update(*This, #True)
      SetGadgetState(*This\PreviewGadget, ImageID(*This\BackFuture))
      *This\IsCountDownActive = #True
    EndIf
    
  EndProcedure
  
  Procedure SaveScoreFile(*This.Private_Members)
    
    *This\Score\CreateScoreFile(#PB_Any, *This\ScoreFileName)
    
  EndProcedure
  
  Procedure ShowScoreTables(*This.Private_Members, *Language.Language::Language)
    
    If *This\ScoreWindow\OpenEx(*Language\Message("Score Tables"), #PB_Window_ScreenCentered | #PB_Window_SystemMenu)
      
      *This\Score\ExamineOnlineScore()
      
      CompilerSelect #PB_Compiler_OS
          
        CompilerCase #PB_OS_Windows 
          ListWidth.l = *This\ScoreWindow\Width()-40
          ListHeight.l = *This\ScoreWindow\Height()-85
          PanelWidth.l = *This\ScoreWindow\Width()-25
          PanelHeight.l = *This\ScoreWindow\Height()-45
          
        CompilerCase #PB_OS_Linux
          ListWidth.l = *This\ScoreWindow\Width()-30
          ListHeight.l = *This\ScoreWindow\Height()-110
          PanelWidth.l = *This\ScoreWindow\Width()-20
          PanelHeight.l = *This\ScoreWindow\Height()-60
                    
        CompilerCase #PB_OS_MacOS
          ListWidth.l = *This\ScoreWindow\Width()-30
          ListHeight.l = *This\ScoreWindow\Height()-110
          PanelWidth.l = *This\ScoreWindow\Width()-20
          PanelHeight.l = *This\ScoreWindow\Height()-60
          
      CompilerEndSelect
      
      OnlinePanelHandle = PanelGadget(#PB_Any, 5, 5, *This\ScoreWindow\Width()-10, *This\ScoreWindow\Height()-10)
        
        AddGadgetItem(OnlinePanelHandle, 0, *Language\Message("Offline"))
        
        PanelHandle = PanelGadget(#PB_Any, 5, 5, PanelWidth, PanelHeight)
          AddGadgetItem(PanelHandle, 0, *Language\Message("Sprint Mode"))
          
          OfflineSprintListIconHandle = ListIconGadget(#PB_Any, 5, 5, ListWidth, ListHeight, *Language\Message("Name"), 150)
          AddGadgetColumn(OfflineSprintListIconHandle, 1, *Language\Message("Total time"), 150)
          
          *This\Score\ResetOfflineSprint()
          
          While *This\Score\NextOfflineSprint()  
            *Player.Player::Player = *This\Score\GetOfflineSprint()
            AddGadgetItem(OfflineSprintListIconHandle, -1, *Player\GetName() + Chr(10) + FormatMilliSeconds::DoIt("%hh:%mm:%ss", *Player\GetTotalTime()))
          Wend
          
          AddGadgetItem(PanelHandle, 1, *Language\Message("Endurance Mode"))
          OfflineEnduranceListIconHandle = ListIconGadget(#PB_Any, 5, 5, ListWidth, ListHeight, *Language\Message("Name"), 150)
          AddGadgetColumn(OfflineEnduranceListIconHandle, 1, *Language\Message("Total time"), 150)
          
          *This\Score\ResetOfflineEndurance()
          
          While *This\Score\NextOfflineEndurance()  
            *Player.Player::Player = *This\Score\GetOfflineEndurance()
            AddGadgetItem(OfflineEnduranceListIconHandle, -1, *Player\GetName() + Chr(10) + FormatMilliSeconds::DoIt("%hh:%mm:%ss", *Player\GetTotalTime()))
          Wend
          
        CloseGadgetList() 
        
        If *This\Mode = 0
          SetGadgetState(PanelHandle, 0)
        ElseIf *This\Mode = 1
          SetGadgetState(PanelHandle, 1)
        EndIf
        
        AddGadgetItem(OnlinePanelHandle, 1, *Language\Message("Online"))
        
        PanelHandle = PanelGadget(#PB_Any, 5, 5, PanelWidth, PanelHeight)
          
          AddGadgetItem(PanelHandle,0, *Language\Message("Sprint Mode"))
          
          OnlineSprintListIconHandle = ListIconGadget(#PB_Any, 5, 5, ListWidth, ListHeight, *Language\Message("Name"), 150)
          AddGadgetColumn(OnlineSprintListIconHandle, 1, *Language\Message("Total time"), 150)
          
          *This\Score\ResetOnlineSprint()
          
          While *This\Score\NextOnlineSprint()  
            *Player.Player::Player = *This\Score\GetOnlineSprint()
            AddGadgetItem(OnlineSprintListIconHandle, -1, *Player\GetName() + Chr(10) + FormatMilliSeconds::DoIt("%hh:%mm:%ss", *Player\GetTotalTime()))
          Wend
          
          AddGadgetItem(PanelHandle, 1, *Language\Message("Endurance Mode"))
          OnlineEnduranceListIconHandle = ListIconGadget(#PB_Any, 5, 5, ListWidth, ListHeight, *Language\Message("Name"), 150)
          AddGadgetColumn(OnlineEnduranceListIconHandle, 1, *Language\Message("Total time"), 150)
          
          *This\Score\ResetOnlineEndurance()
          
          While *This\Score\NextOnlineEndurance()  
            *Player.Player::Player = *This\Score\GetOnlineEndurance()
            AddGadgetItem(OnlineEnduranceListIconHandle, -1, *Player\GetName() + Chr(10) + FormatMilliSeconds::DoIt("%hh:%mm:%ss", *Player\GetTotalTime()))
          Wend
          
        CloseGadgetList() 
        
        If *This\Mode = 0
          SetGadgetState(PanelHandle, 0)
        ElseIf *This\Mode = 1
          SetGadgetState(PanelHandle, 1)
        EndIf
 
      CloseGadgetList()
      
      If *This\Online = 0
        SetGadgetState(OnlinePanelHandle, 0)
      ElseIf *This\Online = 1
        SetGadgetState(OnlinePanelHandle, 1)
      EndIf
      
      Repeat
        
        Select WaitWindowEvent()
            
          Case #PB_Event_Menu
            
            Select EventMenu()
                
            EndSelect
            
          Case #PB_Event_Gadget
            
            Select EventGadget()
                
            EndSelect
            
          Case #PB_Event_CloseWindow
            
            Select EventWindow()
                
              Case *This\ScoreWindow\GetHandle()
                Exit_Condition = #True
                
            EndSelect
            
        EndSelect
        
      Until Exit_Condition = #True

      CloseWindow(*This\ScoreWindow\GetHandle())
      
    EndIf
    
  EndProcedure
  
  Procedure ReadPrefs(*This.Private_Members, GroupName.s)
    
    PreferenceGroup(GroupName)
    
    *This\Mode = ReadPreferenceLong("Mode", *This\Mode)
    *This\Online = ReadPreferenceLong("Online", *This\Online)
    
  EndProcedure
  
  Procedure WritePrefs(*This.Private_Members, GroupName.s)
    
    PreferenceGroup(GroupName)
    
    WritePreferenceLong("Mode", *This\Mode)
    WritePreferenceLong("Online", *This\Online)
    
  EndProcedure
  
  Procedure Free(*This.Private_Members)

    If *This\Score <> #Null
      *This\Score\Free()
    EndIf

    If *This\Player <> #Null
      *This\Player\Free()
    EndIf

    If *This\Chrono <> #Null
      *This\Chrono\Free()
    EndIf

    ClearStructure(*This, Private_Members)
    FreeStructure(*This)

  EndProcedure

  Procedure.i New(P_UserPath.s)

    *This.Private_Members = AllocateStructure(Private_Members)
    *This\VirtualTable = ?START_METHODS
    
    *This\Score = Score::New(20)
    *This\Player = Player::New(UCase(UserName()), 0, 0, 0, #True)
    *This\Chrono = Chrono::New()
    *This\ScoreWindow = Window::New(0, 0, 500, 500, #False)
    
    *This\ScoreFileName = P_UserPath + "Score.dat"
    *This\Online = #True
    
    *This\BlockImage[#GAME_BLOCK_DUMMY] = BlockImage(0)
    *This\BlockImage[#GAME_BLOCK_GREEN] = BlockImage(RGB(000, 255, 000))
    *This\BlockImage[#GAME_BLOCK_RED] = BlockImage(RGB(255, 000, 000))
    *This\BlockImage[#GAME_BLOCK_BLUE] = BlockImage(RGB(000, 000, 255))
    *This\BlockImage[#GAME_BLOCK_ORANGE] = BlockImage(RGB(255, 125, 000))
    *This\BlockImage[#GAME_BLOCK_YELLOW] = BlockImage(RGB(255, 255, 000))
    *This\BlockImage[#GAME_BLOCK_PURPLE] = BlockImage(RGB(125, 000, 255))
    *This\BlockImage[#GAME_BLOCK_GRAY] = BlockImage(RGB(125, 125, 125))
    *This\BlockImage[#GAME_BLOCK_MAGENTA] = BlockImage(RGB(255, 000, 255))
    
    ; Bloc Barre (1)
    *This\Shape(#GAME_BLOCK_GREEN, 1) = %0100010001000100
    *This\Shape(#GAME_BLOCK_GREEN, 2) = %0000111100000000
    *This\Shape(#GAME_BLOCK_GREEN, 3) = %0100010001000100
    *This\Shape(#GAME_BLOCK_GREEN, 4) = %0000111100000000
    
    ; Bloc carr (2)
    *This\Shape(#GAME_BLOCK_RED, 1) = %0000011001100000
    *This\Shape(#GAME_BLOCK_RED, 2) = %0000011001100000
    *This\Shape(#GAME_BLOCK_RED, 3) = %0000011001100000
    *This\Shape(#GAME_BLOCK_RED, 4) = %0000011001100000
   
    ; Bloc en L (3)
    *This\Shape(#GAME_BLOCK_BLUE, 1) = %0110010001000000
    *This\Shape(#GAME_BLOCK_BLUE, 2) = %1110001000000000
    *This\Shape(#GAME_BLOCK_BLUE, 3) = %0010001001100000
    *This\Shape(#GAME_BLOCK_BLUE, 4) = %1000111000000000
  
    ; Bloc en T (4)
    *This\Shape(#GAME_BLOCK_ORANGE, 1) = %1110010000000000
    *This\Shape(#GAME_BLOCK_ORANGE, 2) = %0010011000100000
    *This\Shape(#GAME_BLOCK_ORANGE, 3) = %0000010011100000
    *This\Shape(#GAME_BLOCK_ORANGE, 4) = %1000110010000000
    
    ; Bloc en S Invers (5)
    *This\Shape(#GAME_BLOCK_YELLOW, 1) = %1100011000000000
    *This\Shape(#GAME_BLOCK_YELLOW, 2) = %0100110010000000
    *This\Shape(#GAME_BLOCK_YELLOW, 3) = %1100011000000000
    *This\Shape(#GAME_BLOCK_YELLOW, 4) = %0100110010000000
 
    ; Bloc en S (6)
    *This\Shape(#GAME_BLOCK_PURPLE, 1) = %0110110000000000
    *This\Shape(#GAME_BLOCK_PURPLE, 2) = %1000110001000000
    *This\Shape(#GAME_BLOCK_PURPLE, 3) = %0110110000000000
    *This\Shape(#GAME_BLOCK_PURPLE, 4) = %1000110001000000
 
    ; Bloc en L Invers (7)
    *This\Shape(#GAME_BLOCK_GRAY, 1) = %0110001000100000
    *This\Shape(#GAME_BLOCK_GRAY, 2) = %0010111000000000
    *This\Shape(#GAME_BLOCK_GRAY, 3) = %0100010001100000
    *This\Shape(#GAME_BLOCK_GRAY, 4) = %1110100000000000
  
    ; Bloc en U (8)
    *This\Shape(#GAME_BLOCK_MAGENTA, 1) = %1110101000000000
    *This\Shape(#GAME_BLOCK_MAGENTA, 2) = %1100100011000000
    *This\Shape(#GAME_BLOCK_MAGENTA, 3) = %1010111000000000
    *This\Shape(#GAME_BLOCK_MAGENTA, 4) = %1100010011000000
    
    Update(*This, #True)
    
    If FileSize(*This\ScoreFileName) <> -1
      *This\Score\ReadScoreFile(#PB_Any, *This\ScoreFileName)
    EndIf
    
    ProcedureReturn *This
  EndProcedure

  DataSection
    START_METHODS:
    Data.i @GetMode()
    Data.i @GetOnline()
    Data.i @ToggleMode()
    Data.i @ToggleOnline()
    Data.i @CreateGadgets()
    Data.i @UpdateChronoGadget()
    Data.i @UpdateScoreGadget()
    Data.i @GetStartButtonHandle()
    Data.i @GetToggleModeButtonHandle()
    Data.i @GetShowScoreButtonHandle()
    Data.i @GetToggleOnlineButtonHandle()
    Data.i @RefreshShape()
    Data.i @RandomizeShape()
    Data.i @Update()
    Data.i @CountDownManager()
    Data.i @MoveShapeX()
    Data.i @MoveShapeY()
    Data.i @RotateShape()
    Data.i @StartNewGame()
    Data.i @SaveScoreFile()
    Data.i @ShowScoreTables()
    Data.i @ReadPrefs()
    Data.i @WritePrefs()
    Data.i @Free()
    END_METHODS:
    
    Number5:
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,1,1,1,1,1,1,0,0
    Data.b 0,0,1,0,0,0,0,0,0,0
    Data.b 0,0,1,0,0,0,0,0,0,0
    Data.b 0,0,1,1,1,1,1,0,0,0
    Data.b 0,0,0,0,0,0,0,1,0,0
    Data.b 0,0,0,0,0,0,0,1,0,0
    Data.b 0,0,0,0,0,0,0,1,0,0
    Data.b 0,0,1,0,0,0,0,1,0,0
    Data.b 0,0,0,1,1,1,1,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    
    Number4:
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,1,0,0,0,1,0,0,0
    Data.b 0,0,1,0,0,0,1,0,0,0
    Data.b 0,0,1,0,0,0,1,0,0,0
    Data.b 0,0,1,0,0,0,1,0,0,0
    Data.b 0,0,1,1,1,1,1,1,0,0
    Data.b 0,0,0,0,0,0,1,0,0,0
    Data.b 0,0,0,0,0,0,1,0,0,0
    Data.b 0,0,0,0,0,0,1,0,0,0
    Data.b 0,0,0,0,0,0,1,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    
    Number3:
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,1,1,1,1,0,0,0
    Data.b 0,0,1,0,0,0,0,1,0,0
    Data.b 0,0,0,0,0,0,0,1,0,0
    Data.b 0,0,0,0,0,0,0,1,0,0
    Data.b 0,0,0,0,1,1,1,0,0,0
    Data.b 0,0,0,0,0,0,0,1,0,0
    Data.b 0,0,0,0,0,0,0,1,0,0
    Data.b 0,0,1,0,0,0,0,1,0,0
    Data.b 0,0,0,1,1,1,1,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    
    Number2:
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,1,1,1,1,0,0,0
    Data.b 0,0,1,0,0,0,0,1,0,0
    Data.b 0,0,0,0,0,0,0,1,0,0
    Data.b 0,0,0,0,0,0,1,0,0,0
    Data.b 0,0,0,0,0,1,0,0,0,0
    Data.b 0,0,0,0,1,0,0,0,0,0
    Data.b 0,0,0,1,0,0,0,0,0,0
    Data.b 0,0,1,0,0,0,0,0,0,0
    Data.b 0,0,1,1,1,1,1,1,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    
    Number1:
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,1,0,0,0,0
    Data.b 0,0,0,0,1,1,0,0,0,0
    Data.b 0,0,0,1,0,1,0,0,0,0
    Data.b 0,0,1,0,0,1,0,0,0,0
    Data.b 0,0,0,0,0,1,0,0,0,0
    Data.b 0,0,0,0,0,1,0,0,0,0
    Data.b 0,0,0,0,0,1,0,0,0,0
    Data.b 0,0,0,0,0,1,0,0,0,0
    Data.b 0,0,1,1,1,1,1,1,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    
    Number0:
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,1,1,1,1,0,0,0
    Data.b 0,0,1,0,0,0,0,1,0,0
    Data.b 0,0,1,0,0,0,0,1,0,0
    Data.b 0,0,1,0,0,0,0,1,0,0
    Data.b 0,0,1,0,0,0,0,1,0,0
    Data.b 0,0,1,0,0,0,0,1,0,0
    Data.b 0,0,1,0,0,0,0,1,0,0
    Data.b 0,0,1,0,0,0,0,1,0,0
    Data.b 0,0,0,1,1,1,1,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    Data.b 0,0,0,0,0,0,0,0,0,0
    
  EndDataSection
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (91000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.71 beta 1 LTS (Linux - x64)
; Folding = -5jDC7-
; EnableXP
; CompileSourceDirectory