; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Object - V0.0.1
; Nom du projet : Le nom du projet ici
; Nom du fichier : Nom du fichier
; Version du fichier : 0.0.0
; Programmation :  vrifier
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 15-05-2019
; Mise  jour : 15-05-2019
; Cod pour PureBasic : V5.71 beta 1 LTS
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule SpeedTetris
  
  Interface SpeedTetris
    
    CreateWindow()
    EventManager()
    Shutdown()
    Free()
    
  EndInterface
  
  Declare.i New()
  
EndDeclareModule

Module SpeedTetris
  
  #Version = " - V1.0.0"
  
  Enumeration

    #Timer_AutoMoveDown
    
    #ShortCut_Move_Left
    #ShortCut_Move_Right
    #ShortCut_Move_Down
    #ShortCut_Rotate_Left
    #ShortCut_Rotate_Right
    
  EndEnumeration
  
  Structure Private_Members
    
    VirtualTable.i
    PrefFileName.s
    MainWin.Window::Window
    Language.Language::Language
    Game.Game::Game
    LanguageButton.i
    
  EndStructure
  
  Procedure CreatePrefs(*This.Private_Members)
    
    If CreatePreferences(*This\PrefFileName)
      
      *This\MainWin\WritePrefs("MainWindow")
      *This\Language\WritePrefs("Language")
      *This\Game\WritePrefs("Game")
      
      ClosePreferences()
      
    EndIf
    
  EndProcedure
  
  
  Procedure OpenPrefs(*This.Private_Members)
    
    If OpenPreferences(*This\PrefFileName)
      
      *This\MainWin\ReadPrefs("MainWindow")
      *This\Language\ReadPrefs("Language")
      *This\Game\ReadPrefs("Game")
      
      ClosePreferences()
      
    EndIf
    
  EndProcedure
  
  
  Procedure CreateWindow(*This.Private_Members)
    
    If *This\MainWin\Open()
      
      *This\Game\Update(#True)
      *This\Game\CreateGadgets()
      
      *This\LanguageButton = ButtonGadget(#PB_Any, GadgetX(*This\Game\GetToggleOnlineButtonHandle()), GadgetY(*This\Game\GetToggleOnlineButtonHandle()) + GadgetHeight(*This\Game\GetToggleOnlineButtonHandle()) + 5, GadgetWidth(*This\Game\GetToggleOnlineButtonHandle()), 34, "")
      
      *This\Language\To_GUI()
      
      AddKeyboardShortcut(*This\MainWin\GetHandle(), #PB_Shortcut_A, #ShortCut_Rotate_Left)
      AddKeyboardShortcut(*This\MainWin\GetHandle(), #PB_Shortcut_D, #ShortCut_Rotate_Right)
      AddKeyboardShortcut(*This\MainWin\GetHandle(), #PB_Shortcut_Left, #ShortCut_Move_Left)
      AddKeyboardShortcut(*This\MainWin\GetHandle(), #PB_Shortcut_Right, #ShortCut_Move_Right)
      AddKeyboardShortcut(*This\MainWin\GetHandle(), #PB_Shortcut_Down , #ShortCut_Move_Down)
      AddWindowTimer(*This\MainWin\GetHandle(), #Timer_AutoMoveDown, 1000)
      *This\Game\UpdateScoreGadget()
      
    EndIf
    
  EndProcedure
  
  Procedure EventManager(*This.Private_Members)
    
    Exit_Condition.b = #False
    
    Repeat
      
      *This\Game\UpdateChronoGadget()

      Select WaitWindowEvent(250)
          
        Case #PB_Event_Menu
          
          Select EventMenu()
              
            Case #ShortCut_Move_Left
              *This\Game\MoveShapeX(-1)
              
            Case #ShortCut_Move_Right
              *This\Game\MoveShapeX(1)
              
            Case #ShortCut_Move_Down
              *This\Game\MoveShapeY(1, *This\Language)
              
            Case #ShortCut_Rotate_Left
              *This\Game\RotateShape(-1)
              
            Case #ShortCut_Rotate_Right
              *This\Game\RotateShape(1)
              
          EndSelect
          
        Case #PB_Event_Timer
          
          Select EventTimer()
              
            Case #Timer_AutoMoveDown
              *This\Game\MoveShapeY(1, *This\Language)
              *This\Game\CountDownManager()
              
          EndSelect
          
        Case #PB_Event_Gadget
          
          Select EventGadget()
              
            Case *This\LanguageButton
              *This\Language\Requester()
              
            Case *This\Game\GetStartButtonHandle()
              *This\Game\StartNewGame()
              
            Case *This\Game\GetToggleModeButtonHandle()
              
              *This\Game\ToggleMode()
              
              If *This\Game\GetMode() = 0
                SetGadgetText(*This\Game\GetToggleModeButtonHandle(), *This\Language\Message("Sprint Mode"))
              Else
                SetGadgetText(*This\Game\GetToggleModeButtonHandle(), *This\Language\Message("Endurance Mode"))
              EndIf
              
            Case *This\Game\GetToggleOnlineButtonHandle()
              
              *This\Game\ToggleOnline()
              
              If *This\Game\GetOnline() = 0
                SetGadgetText(*This\Game\GetToggleOnlineButtonHandle(), *This\Language\Message("Offline"))
              Else
                SetGadgetText(*This\Game\GetToggleOnlineButtonHandle(), *This\Language\Message("Online"))
              EndIf
              
              
            Case *This\Game\GetShowScoreButtonHandle()
              *This\Game\ShowScoreTables(*This\Language)
              
          EndSelect
          
        Case #PB_Event_CloseWindow
          
          Select EventWindow()
              
            Case *This\MainWin\GetHandle()
              Exit_Condition = #True
              
          EndSelect
          
      EndSelect
      
    Until Exit_Condition = #True
    
  EndProcedure
  
  Procedure Shutdown(*This.Private_Members)
    
    *This\MainWin\GetCurrentPosition()
    CreatePrefs(*This)
    
    *This\Game\SaveScoreFile()
    
  EndProcedure

  Procedure Free(*This.Private_Members)
    
    If *This\MainWin <> #Null
      *This\MainWin\Free()
    EndIf

    If *This\Language <> #Null
      *This\Language\Free()
    EndIf

    If *This\Game <> #Null
      *This\Game\Free()
    EndIf

    ClearStructure(*This, Private_Members)
    FreeStructure(*This)

  EndProcedure
  
  Procedure Private_Language_To_GUI(*This.Private_Members)

    *This\MainWin\SetTitle(*This\Language\Message("Speed Tetris") + #Version)
    
    SetGadgetText(*This\Game\GetStartButtonHandle(), *This\Language\Message("Start Game"))
    
    If *This\Game\GetMode() = 0
      SetGadgetText(*This\Game\GetToggleModeButtonHandle(), *This\Language\Message("Sprint Mode"))
    Else
      SetGadgetText(*This\Game\GetToggleModeButtonHandle(), *This\Language\Message("Endurance Mode"))
    EndIf
    
    If *This\Game\GetOnline() = 0
      SetGadgetText(*This\Game\GetToggleOnlineButtonHandle(), *This\Language\Message("Offline"))
    Else
      SetGadgetText(*This\Game\GetToggleOnlineButtonHandle(), *This\Language\Message("Online"))
    EndIf
    
    
    
    SetGadgetText(*This\Game\GetShowScoreButtonHandle(), *This\Language\Message("Show Score"))
    
    
    SetGadgetText(*This\LanguageButton, *This\Language\Message("Language Requester"))
    
  EndProcedure
  
   CompilerIf #PB_Compiler_Debugger
     
     Procedure BuiltLanguageDefaultFiles(P_LanguagePath.s)
       
       BuiltPathDirectory::DoIt(P_LanguagePath)
       
       English.Language::Language = Language::New(P_LanguagePath, "English.xml")
       French.Language::Language = Language::New(P_LanguagePath, "Franais.xml")
       
       English\AddTableElement("Speed Tetris", "Speed Tetris")
       French\AddTableElement("Speed Tetris", "Speed Tetris")

       English\AddTableElement("Language Requester", "Choose language")
       French\AddTableElement("Language Requester", "Choix de la langue")
       
       English\AddTableElement("OK", "OK")
       French\AddTableElement("OK", "OK")
       
       English\AddTableElement("Cancel", "Cancel")
       French\AddTableElement("Cancel", "Annuler")
       
       English\AddTableElement("Start Game", "Start Game")
       French\AddTableElement("Start Game", "Lancer le jeu")
       
       English\AddTableElement("Sprint Mode", "Sprint Mode")
       French\AddTableElement("Sprint Mode", "Mode Sprint")
       
       English\AddTableElement("Endurance Mode", "Endurance Mode")
       French\AddTableElement("Endurance Mode", "Mode Endurance")
       
       English\AddTableElement("Show Score", "Show Score")
       French\AddTableElement("Show Score", "Afficher le pointage")
       
       English\AddTableElement("Name", "Name")
       French\AddTableElement("Name", "Nom")
       
       English\AddTableElement("Total time", "Total time")
       French\AddTableElement("Total time", "Temps total")
       
       English\AddTableElement("Score Tables", "Score Tables")
       French\AddTableElement("Score Tables", "Tables de pointage")
       
       English\AddTableElement("Offline", "Offline")
       French\AddTableElement("Offline", "Hors ligne")
       
       English\AddTableElement("Online", "Online")
       French\AddTableElement("Online", "En ligne")
       
       English\AddTableElement("Good news", "Good news")
       French\AddTableElement("Good news", "Bonne nouvelle")
       
       English\AddTableElement("Your score is qualified for the position : ", "Your score is qualified for the position : ")
       French\AddTableElement("Your score is qualified for the position : ", "Votre pointage se qualifie pour la position : ")
       
       English\AddTableElement("Please enter your name :", "Please enter your name :")
       French\AddTableElement("Please enter your name :", "S'il vous plat entrez votre nom :")
       
       English\CreateTableFile()
       French\CreateTableFile()
       
       English\Free()
       French\Free()
       
     EndProcedure
     
   CompilerEndIf  
  
  
  Procedure.i New()

    *This.Private_Members = AllocateStructure(Private_Members)
    *This\VirtualTable = ?START_METHODS
    
    CompilerSelect #PB_Compiler_OS
        
      CompilerCase #PB_OS_Windows 
        UserPath.s = GetEnvironmentVariable("APPDATA") + #PS$ + "SpeedTetris" + #PS$
        
        If Left(UserPath, 2) <> "C:"
          UserPath = "C:" + #PS$ + UserPath
        EndIf
        
      CompilerCase #PB_OS_Linux
        UserPath.s = GetHomeDirectory() + ".SpeedTetris" + #PS$
        
      CompilerCase #PB_OS_MacOS
        UserPath.s = GetHomeDirectory() + ".SpeedTetris" + #PS$; This might be wrong
        
    CompilerEndSelect

    InitNetwork()

    LanguagePath.s = GetPathPart(ProgramFilename()) + "language" + #PS$
    
    BuiltPathDirectory::DoIt(UserPath)
    
   CompilerIf #PB_Compiler_Debugger
      BuiltLanguageDefaultFiles(LanguagePath)
   CompilerEndIf  
    
    
    *This\PrefFileName = UserPath + "SpeedTetris.prefs"

    *This\MainWin = Window::New(50, 50, 532, 522, #False)
    
    If FindString(GetEnvironmentVariable("LANGUAGE"), "fr")
      *This\Language = Language::New(LanguagePath, "Franais.xml", @Private_Language_To_GUI(), *This)
    Else
      *This\Language = Language::New(LanguagePath, "English.xml", @Private_Language_To_GUI(), *This)
    EndIf
    
    *This\Game = Game::New(UserPath)

    OpenPrefs(*This)
    
    *This\Language\LoadTableFile()
    
    ProcedureReturn *This
  EndProcedure

  DataSection
    START_METHODS:
    Data.i @CreateWindow()
    Data.i @EventManager()
    Data.i @Shutdown()
    Data.i @Free()
    END_METHODS:
  EndDataSection

EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (173000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.71 beta 1 LTS (Linux - x64)
; Folding = ----
; EnableXP
; CompileSourceDirectory