; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : DownloadToString - Module
; Nom du fichier : DownloadToString - Module.pb
; Version du fichier : 0.0.0
; Programmation : En cours
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 25-05-2019
; Mise  jour : 25-05-2019
; Code PureBasic : V5.71 beta 1 LTS
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;
; Auteur original : STARGATE forum Allemand :
; https://www.purebasic.fr/german/viewtopic.php?f=8&t=12857
;
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule DownloadToString
  
  Declare.s DoIt(URL.s, TimeOut.l = 5000)
  
EndDeclareModule

Module DownloadToString
  
  Procedure.s DoIt(URL.s, TimeOut.l = 5000)
    
    Protected Event, Time, Size, String$
    Protected BufferSize = $1000
    Protected *Buffer = AllocateMemory(BufferSize)
    Protected ServerName$ = GetURLPart(URL, #PB_URL_Site)
    Protected ConnectionID = OpenNetworkConnection(ServerName$, 80)
    
    If ConnectionID
      
      SendNetworkString(ConnectionID, "GET " + URL + " HTTP/1.0" + #LFCR$ + #LFCR$)
      Time = ElapsedMilliseconds()
      
      Repeat
        Delay(10)
        Event = NetworkClientEvent(ConnectionID)
      Until Event Or ElapsedMilliseconds() - Time > TimeOut
      
      If Event
        
        Repeat
          Size = ReceiveNetworkData(ConnectionID, *Buffer, BufferSize)
          String$ + PeekS(*Buffer, Size, #PB_Ascii)
        Until Not Size
        
        Inhalt = FindString(String$, #LFCR$, 1)
        
        If Inhalt
          ProcedureReturn Mid(String$, Inhalt + 3)
        Else
          ProcedureReturn String$
        EndIf
        
      EndIf
      
    EndIf
    
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.71 beta 1 LTS (Linux - x64)
; Folding = -
; EnableXP
; CompileSourceDirectory