; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Object - V0.0.1
; Nom du projet : Le nom du projet ici
; Nom du fichier : Nom du fichier
; Version du fichier : 0.0.0
; Programmation :  vrifier
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 16-05-2019
; Mise  jour : 16-05-2019
; Cod pour PureBasic : V5.71 beta 1 LTS
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Score

  Interface Score

    GetRecordSize.l()
    GetOfflineSprint.i()
    GetOfflineEndurance.i()
    GetOnlineSprint.i()
    GetOnlineEndurance.i()
    GetOnlineScoreKey.s()
    GetOnlineScoreURL.s()
    SetRecordSize(P_RecordSize.l)
    SetOnlineScoreKey(P_OnlineScoreKey.s)
    SetOnlineScoreURL(P_OnlineScoreURL.s)
    CreateScoreFile(FileID.i, FileName.s)
    ReadScoreFile(FileID.i, FileName.s)
    InsertQualifiedOfflinePlayerScore(*Player.Player::Player, Mode.b)
    InsertQualifiedOnlinePlayerScore(*Player.Player::Player, Mode.b)
    ExamineOnlineScore(Start.l = 1, Count.l = 0)
    AddOnlineScoreItem(*Player.Player::Player, Mode.b)
    ResetOfflineSprint()
    NextOfflineSprint()
    ResetOfflineEndurance()
    NextOfflineEndurance()
    ResetOnlineSprint()
    NextOnlineSprint()
    ResetOnlineEndurance()
    NextOnlineEndurance() 
    Free()

  EndInterface

  Declare.i New(P_RecordSize.l)

EndDeclareModule

Module Score

  Structure Private_Members

    VirtualTable.i
    RecordSize.l
    OnlineScoreKey.s
    OnlineScoreURL.s
    
    List OfflineSprint.Player::Player()
    List OfflineEndurance.Player::Player()
    List OnlineSprint.Player::Player()
    List OnlineEndurance.Player::Player()
    
  EndStructure
  
  Procedure Private_SortScoreByTotalTime(List Score.Player::Player())
    
    BubbleSortSwapped.b = #True
    
    While BubbleSortSwapped = #True
      
      BubbleSortSwapped = #False
      BubbleIndex = ListSize(Score()) - 1
      StoneIndex = 0
      
      For Index = 0 To ListSize(Score()) - 2
        
        SelectElement(Score(), StoneIndex)
        StoneTotalTime00.q = Score()\GetTotalTime()
        *Stone00 = @Score()
        
        SelectElement(Score(), StoneIndex + 1)
        StoneTotalTime01.q = Score()\GetTotalTime()
        *Stone01 = @Score()
        
        If StoneTotalTime00 > StoneTotalTime01
          SwapElements(Score(), *Stone00, *Stone01)
          BubbleSortSwapped = #True
        EndIf
        
        SelectElement(Score(), BubbleIndex)
        BubbleTotalTime00.q = Score()\GetTotalTime()
        *Bubble00 = @Score()
        
        SelectElement(Score(), BubbleIndex - 1)
        BubbleTotalTime01.q = Score()\GetTotalTime()
        *Bubble01 = @Score()
        
        If BubbleTotalTime00 < BubbleTotalTime01
          SwapElements(Score(), *Bubble00, *Bubble01)
          BubbleSortSwapped = #True
        EndIf
        
        BubbleIndex - 1
        StoneIndex + 1
        
      Next
      
    Wend
    
  EndProcedure
  
  Procedure Private_LinearSearchScoreByTotalTime(List Score.Player::Player(), SearchValue.q)
    
    Protected IsFoundAtIndex.l = -1
    
    ForEach Score()
      
      If Score()\GetTotalTime() = SearchValue
        IsFoundAtIndex = ListIndex(Score())
        Break
      EndIf
      
    Next
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  Procedure Private_LinearSearchScoreByMostRecentEntry(List Score.Player::Player(), SearchValue.b)
    
    Protected IsFoundAtIndex.l = -1
    
    ForEach Score()
      
      If Score()\GetMostRecentEntry() = SearchValue
        IsFoundAtIndex = ListIndex(Score())
        Break
      EndIf
      
    Next
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  Procedure Private_AddOfflineSprintScore(*This.Private_Members, *P_Sprint.Player::Player)
    
    AddElement(*This\OfflineSprint())
    *This\OfflineSprint() = Player::New(*P_Sprint\GetName(), *P_Sprint\GetTotalTime(), *P_Sprint\GetPoints(), *P_Sprint\GetCompletedLine(), *P_Sprint\GetMostRecentEntry())
    
  EndProcedure
  
  Procedure Private_InsertOfflineSprintScore(*This.Private_Members, *P_Sprint.Player::Player)
    
    InsertElement(*This\OfflineSprint())
    *This\OfflineSprint() = Player::New(*P_Sprint\GetName(), *P_Sprint\GetTotalTime(), *P_Sprint\GetPoints(), *P_Sprint\GetCompletedLine(), *P_Sprint\GetMostRecentEntry())
    
  EndProcedure
  
  Procedure Private_AddOfflineEnduranceScore(*This.Private_Members, *P_Endurance.Player::Player)
    
    AddElement(*This\OfflineEndurance())
    *This\OfflineEndurance() = Player::New(*P_Endurance\GetName(), *P_Endurance\GetTotalTime(), *P_Endurance\GetPoints(), *P_Endurance\GetCompletedLine(), *P_Endurance\GetMostRecentEntry())
    
  EndProcedure
  
  Procedure Private_InsertOfflineEnduranceScore(*This.Private_Members, *P_Endurance.Player::Player)
    
    InsertElement(*This\OfflineEndurance())
    *This\OfflineEndurance() = Player::New(*P_Endurance\GetName(), *P_Endurance\GetTotalTime(), *P_Endurance\GetPoints(), *P_Endurance\GetCompletedLine(), *P_Endurance\GetMostRecentEntry())
    
  EndProcedure
  
  Procedure Private_AddOnlineSprintScore(*This.Private_Members, *P_Sprint.Player::Player)
    
    AddElement(*This\OnlineSprint())
    *This\OnlineSprint() = Player::New(*P_Sprint\GetName(), *P_Sprint\GetTotalTime(), *P_Sprint\GetPoints(), *P_Sprint\GetCompletedLine(), *P_Sprint\GetMostRecentEntry())
    
  EndProcedure
  
  Procedure Private_InsertOnlineSprintScore(*This.Private_Members, *P_Sprint.Player::Player)
    
    InsertElement(*This\OnlineSprint())
    *This\OnlineSprint() = Player::New(*P_Sprint\GetName(), *P_Sprint\GetTotalTime(), *P_Sprint\GetPoints(), *P_Sprint\GetCompletedLine(), *P_Sprint\GetMostRecentEntry())
    
  EndProcedure
  
  Procedure Private_AddOnlineEnduranceScore(*This.Private_Members, *P_Endurance.Player::Player)
    
    AddElement(*This\OnlineEndurance())
    *This\OnlineEndurance() = Player::New(*P_Endurance\GetName(), *P_Endurance\GetTotalTime(), *P_Endurance\GetPoints(), *P_Endurance\GetCompletedLine(), *P_Endurance\GetMostRecentEntry())
    
  EndProcedure
  
  Procedure Private_InsertOnlineEnduranceScore(*This.Private_Members, *P_Endurance.Player::Player)
    
    InsertElement(*This\OnlineEndurance())
    *This\OnlineEndurance() = Player::New(*P_Endurance\GetName(), *P_Endurance\GetTotalTime(), *P_Endurance\GetPoints(), *P_Endurance\GetCompletedLine(), *P_Endurance\GetMostRecentEntry())
    
  EndProcedure

  Procedure.l GetRecordSize(*This.Private_Members)

    ProcedureReturn *This\RecordSize
  EndProcedure
  
  Procedure.i GetOfflineSprint(*This.Private_Members)
  
    ProcedureReturn *This\OfflineSprint()
  EndProcedure
  
  Procedure.i GetOfflineEndurance(*This.Private_Members)
  
    ProcedureReturn *This\OfflineEndurance()
  EndProcedure
  
  Procedure.i GetOnlineSprint(*This.Private_Members)
  
    ProcedureReturn *This\OnlineSprint()
  EndProcedure
  
  Procedure.i GetOnlineEndurance(*This.Private_Members)
  
    ProcedureReturn *This\OnlineEndurance()
  EndProcedure
  
  Procedure.s GetOnlineScoreKey(*This.Private_Members)

    ProcedureReturn *This\OnlineScoreKey
  EndProcedure

  Procedure.s GetOnlineScoreURL(*This.Private_Members)

    ProcedureReturn *This\OnlineScoreURL
  EndProcedure
 
  Procedure SetRecordSize(*This.Private_Members, P_RecordSize.l)

    *This\RecordSize = P_RecordSize

  EndProcedure
  
  Procedure SetOnlineScoreKey(*This.Private_Members, P_OnlineScoreKey.s)

    *This\OnlineScoreKey = P_OnlineScoreKey

  EndProcedure

  Procedure SetOnlineScoreURL(*This.Private_Members, P_OnlineScoreURL.s)

    *This\OnlineScoreURL = P_OnlineScoreURL

  EndProcedure
  
  Procedure CreateScoreFile(*This.Private_Members, FileID.i, FileName.s)

    FileHandle = CreateFile(FileID, FileName)

    If FileID = #PB_Any
      FileID = FileHandle
    EndIf

    If IsFile(FileID)
      
      WriteLong(FileID, *This\RecordSize)
      
      WriteLong(FileID, ListSize(*This\OfflineSprint()))
      
      ForEach *This\OfflineSprint()
        *This\OfflineSprint()\WritePlayer(FileID)
      Next
      
      WriteLong(FileID, ListSize(*This\OfflineEndurance()))
      
      ForEach *This\OfflineEndurance()
        *This\OfflineEndurance()\WritePlayer(FileID)
      Next
      
      CloseFile(FileID)

    EndIf

  EndProcedure

  Procedure ReadScoreFile(*This.Private_Members, FileID.i, FileName.s)
    
    FileHandle = ReadFile(FileID, FileName)
    
    If FileID = #PB_Any
      FileID = FileHandle
    EndIf
    
    If IsFile(FileID)
      
      *This\RecordSize = ReadLong(FileID)
      
      Sprint_Max = ReadLong(FileID) - 1
      
      For SprintID = 0 To Sprint_Max
        
        AddElement(*This\OfflineSprint())
        *This\OfflineSprint() = Player::New()
        *This\OfflineSprint()\ReadPlayer(FileID)
        
      Next    
      
      Endurance_Max = ReadLong(FileID) - 1
      
      For EnduranceID = 0 To Endurance_Max
        
        AddElement(*This\OfflineEndurance())
        *This\OfflineEndurance() = Player::New()
        *This\OfflineEndurance()\ReadPlayer(FileID)
        
      Next   
      
      CloseFile(FileID)
      
    EndIf
    
  EndProcedure
  
  Procedure InsertQualifiedOfflinePlayerScore(*This.Private_Members, *Player.Player::Player, Mode.b)
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ; Fonctionnement :
    ;
    ; 0. On fait sr que les listes de pointage contient rien de rcent.
    ; 1. Recherche dans la liste pour voir si le score est prsent.
    ; 2. Il n'est pas prsent, on l'ajoute  la liste de pointage
    ; 3. Il est prsent, on vrifie si c'est le mme joueur 
    ; 4. C'est pas le mme joueur, on l'insert dans la liste de pointage
    ; 5. On trie la liste de pointage, du meilleur au pire temps.
    ; 6. Si la liste de pointage compte plus d'lment que le max autoris,
    ;    on enlve le dernier lment.
    ;
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    If Mode < 0
      Mode = 0
    ElseIf Mode > 1
      Mode = 1
    EndIf
    
    Select Mode
        
      Case 0
        
        ForEach *This\OfflineSprint()
          *This\OfflineSprint()\SetMostRecentEntry(#False)
        Next
        
        IsFoundAtIndex = Private_LinearSearchScoreByTotalTime(*This\OfflineSprint(), *Player\GetTotalTime())
        
        If IsFoundAtIndex = -1
          Private_AddOfflineSprintScore(*This, *Player)
        Else
          
          If *Player\GetName() <> *This\OfflineSprint()\GetName()
            Private_InsertOfflineSprintScore(*This, *Player)
          EndIf
          
        EndIf
        
        Private_SortScoreByTotalTime(*This\OfflineSprint()) 
        
        If ListSize(*This\OfflineSprint()) > *This\RecordSize
          LastElement(*This\OfflineSprint())
          *This\OfflineSprint()\Free()
          DeleteElement(*This\OfflineSprint())
        EndIf
        
        IsFoundAtIndex = Private_LinearSearchScoreByMostRecentEntry(*This\OfflineSprint(), #True)
        
      Case 1
        
        ForEach *This\OfflineEndurance()
          *This\OfflineEndurance()\SetMostRecentEntry(#False)
        Next
        
        IsFoundAtIndex = Private_LinearSearchScoreByTotalTime(*This\OfflineEndurance(), *Player\GetTotalTime())
        
        If IsFoundAtIndex = -1
          Private_AddOfflineEnduranceScore(*This, *Player)
        Else
          
          If *Player\GetName() <> *This\OfflineEndurance()\GetName()
            Private_InsertOfflineEnduranceScore(*This, *Player)
          EndIf
          
        EndIf
        
        Private_SortScoreByTotalTime(*This\OfflineEndurance()) 
        
        If ListSize(*This\OfflineEndurance()) > *This\RecordSize
          LastElement(*This\OfflineEndurance())
          *This\OfflineEndurance()\Free()
          DeleteElement(*This\OfflineEndurance())
        EndIf
        
        IsFoundAtIndex = Private_LinearSearchScoreByMostRecentEntry(*This\OfflineEndurance(), #True)
        
    EndSelect
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure

  Procedure InsertQualifiedOnlinePlayerScore(*This.Private_Members, *Player.Player::Player, Mode.b)
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ; Fonctionnement :
    ;
    ; 0. On fait sr que les listes de pointage contient rien de rcent.
    ; 1. Recherche dans la liste pour voir si le score est prsent.
    ; 2. Il n'est pas prsent, on l'ajoute  la liste de pointage
    ; 3. Il est prsent, on vrifie si c'est le mme joueur 
    ; 4. C'est pas le mme joueur, on l'insert dans la liste de pointage
    ; 5. On trie la liste de pointage, du meilleur au pire temps.
    ; 6. Si la liste de pointage compte plus d'lment que le max autoris,
    ;    on enlve le dernier lment.
    ;
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    If Mode < 0
      Mode = 0
    ElseIf Mode > 1
      Mode = 1
    EndIf
    
    Select Mode
        
      Case 0
        
        ForEach *This\OnlineSprint()
          *This\OnlineSprint()\SetMostRecentEntry(#False)
        Next
        
        IsFoundAtIndex = Private_LinearSearchScoreByTotalTime(*This\OnlineSprint(), *Player\GetTotalTime())
        
        If IsFoundAtIndex = -1
          Private_AddOnlineSprintScore(*This, *Player)
        Else
          
          If *Player\GetName() <> *This\OnlineSprint()\GetName()
            Private_InsertOnlineSprintScore(*This, *Player)
          EndIf
          
        EndIf
        
        Private_SortScoreByTotalTime(*This\OnlineSprint()) 
        
        If ListSize(*This\OnlineSprint()) > *This\RecordSize
          LastElement(*This\OnlineSprint())
          *This\OnlineSprint()\Free()
          DeleteElement(*This\OnlineSprint())
        EndIf
        
        IsFoundAtIndex = Private_LinearSearchScoreByMostRecentEntry(*This\OnlineSprint(), #True)
        
      Case 1
        
        ForEach *This\OnlineEndurance()
          *This\OnlineEndurance()\SetMostRecentEntry(#False)
        Next
        
        IsFoundAtIndex = Private_LinearSearchScoreByTotalTime(*This\OnlineEndurance(), *Player\GetTotalTime())
        
        If IsFoundAtIndex = -1
          Private_AddOnlineEnduranceScore(*This, *Player)
        Else
          
          If *Player\GetName() <> *This\OnlineEndurance()\GetName()
            Private_InsertOnlineEnduranceScore(*This, *Player)
          EndIf
          
        EndIf
        
        Private_SortScoreByTotalTime(*This\OnlineEndurance()) 
        
        If ListSize(*This\OnlineEndurance()) > *This\RecordSize
          LastElement(*This\OnlineEndurance())
          *This\OnlineEndurance()\Free()
          DeleteElement(*This\OnlineEndurance())
        EndIf
        
        IsFoundAtIndex = Private_LinearSearchScoreByMostRecentEntry(*This\OnlineEndurance(), #True)
        
    EndSelect
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  Procedure ExamineOnlineScore(*This.Private_Members, Start.l = 1, Count.l = 0)
    
    Protected Get$, Position, OldPosition, Item$
    
    ForEach *This\OnlineSprint()
      If *This\OnlineSprint() <> #Null
        *This\OnlineSprint()\Free()
      EndIf
    Next
    
    ForEach *This\OnlineEndurance()
      If *This\OnlineEndurance() <> #Null
        *This\OnlineEndurance()\Free()
      EndIf
    Next
    
    ClearList(*This\OnlineSprint())
    ClearList(*This\OnlineEndurance())
    
    If Count > 0
      Get$ = "?from=" + Str(Start) + "&to=" + Str(Start+Count)
    Else
      Get$ = "?from=" + Str(Start)
    EndIf
    
    String$ = DownloadToString::DoIt(*This\OnlineScoreURL + Get$)
    
    If String$
      
      Repeat
        
        Position = FindString(String$, Chr(13), OldPosition+1)
        
        If Position
          
          Item$ = StringBetween::FindIt(Mid(String$, OldPosition+1, Position-OldPosition-1), "(", ")") 
          Points.l = Val(StringField(Item$, 1, ", "))
          TotalTime.q = Val(StringField(Item$, 2, ", "))
          CompletedLine.l = Val(StringField(Item$, 3, ", "))
          Mode.b = Val(StringField(Item$, 4, ", "))
          Name.s = RemoveString(StringField(Item$, 5, ", "), Chr(34))
          
          Select Mode
              
            Case 0
              AddElement(*This\OnlineSprint())
              *This\OnlineSprint() = Player::New(Name, TotalTime, Point, CompletedLine, #False)
              
            Case 1
              AddElement(*This\OnlineEndurance())
              *This\OnlineEndurance() = Player::New(Name, TotalTime, Point, CompletedLine, #False)
              
          EndSelect
          
          OldPosition = Position
          
        EndIf
        
      Until Not Position
      
      
      Private_SortScoreByTotalTime(*This\OnlineSprint())
      Private_SortScoreByTotalTime(*This\OnlineEndurance())
      
      ResetList(*This\OnlineSprint())
      ResetList(*This\OnlineEndurance())
      
      ProcedureReturn #True
      
    Else
      Debug "Download failed!" 
    EndIf
    
  EndProcedure
  
  Procedure AddOnlineScoreItem(*This.Private_Members, *Player.Player::Player, Mode.b)
    
    Protected Points$ = Str(*Player\GetPoints())
    Protected TotalTime$ = Str(*Player\GetTotalTime())
    Protected CompletedLine$ = Str(*Player\GetCompletedLine())
    Protected Mode$ = Str(Mode)
    Protected Name$ = URLEncoder(*Player\GetName())
    
    Protected Get$ = "?Points=" + Points$ + "&TotalTime=" + TotalTime$ + "&CompletedLine=" + CompletedLine$  + "&Mode=" + Mode$+ "&Name=" + Name$ + "&Key=" + DESFingerprint(Points$ + TotalTime$ + CompletedLine$ + Mode$ + Name$, *This\OnlineScoreKey)
    
    String$ = DownloadToString::DoIt(*This\OnlineScoreURL + Get$)
    
    If String$
      
      If String$ = "TRUE"
        Debug "High score entry added."
        ProcedureReturn #True
      ElseIf String$ = "FALSE #1"
        Debug "Invalid entry!"
      ElseIf String$ = "FALSE #2"
        Debug "Error when entering (or write to the file)!"
      ElseIf String$ = "FALSE #3"
        Debug "Identical entry!"
      Else
        Debug "Unknown error!"
        Debug String$   
      EndIf
      
    Else
      
      Debug "Download failed!" 
      
    EndIf 
    
  EndProcedure
  
  Procedure ResetOfflineSprint(*This.Private_Members)
    
    ResetList(*This\OfflineSprint())
    
  EndProcedure
  
  Procedure NextOfflineSprint(*This.Private_Members)
  
    ProcedureReturn NextElement(*This\OfflineSprint())
  EndProcedure
 
  Procedure ResetOfflineEndurance(*This.Private_Members)
    
    ResetList(*This\OfflineEndurance())
    
  EndProcedure
  
  Procedure NextOfflineEndurance(*This.Private_Members)
  
    ProcedureReturn NextElement(*This\OfflineEndurance())
  EndProcedure
  
  Procedure ResetOnlineSprint(*This.Private_Members)
    
    ResetList(*This\OnlineSprint())
    
  EndProcedure
  
  Procedure NextOnlineSprint(*This.Private_Members)
  
    ProcedureReturn NextElement(*This\OnlineSprint())
  EndProcedure
 
  Procedure ResetOnlineEndurance(*This.Private_Members)
    
    ResetList(*This\OnlineEndurance())
    
  EndProcedure
  
  Procedure NextOnlineEndurance(*This.Private_Members)
  
    ProcedureReturn NextElement(*This\OnlineEndurance())
  EndProcedure

  Procedure Free(*This.Private_Members)

    ForEach *This\OfflineSprint()
      If *This\OfflineSprint() <> #Null
        *This\OfflineSprint()\Free()
      EndIf
    Next
    
    ForEach *This\OfflineEndurance()
      If *This\OfflineEndurance() <> #Null
        *This\OfflineEndurance()\Free()
      EndIf
    Next
    
    ForEach *This\OnlineSprint()
      If *This\OnlineSprint() <> #Null
        *This\OnlineSprint()\Free()
      EndIf
    Next
    
    ForEach *This\OnlineEndurance()
      If *This\OnlineEndurance() <> #Null
        *This\OnlineEndurance()\Free()
      EndIf
    Next
    
    ClearStructure(*This, Private_Members)
    FreeStructure(*This)

  EndProcedure
  
  Procedure.i New(P_RecordSize.l)

    *This.Private_Members = AllocateStructure(Private_Members)
    *This\VirtualTable = ?START_METHODS
    
    SetRecordSize(*This, P_RecordSize)
    SetOnlineScoreKey(*This, "SPEED_TETRIS")
    SetOnlineScoreURL(*This, "http://gsaumure.x10host.com/speedtetris/HighScore.php")
    
    ProcedureReturn *This
  EndProcedure

  DataSection
    START_METHODS:
    Data.i @GetRecordSize()
    Data.i @GetOfflineSprint()
    Data.i @GetOfflineEndurance()
    Data.i @GetOnlineSprint()
    Data.i @GetOnlineEndurance()
    Data.i @GetOnlineScoreKey()
    Data.i @GetOnlineScoreURL()
    Data.i @SetRecordSize()
    Data.i @SetOnlineScoreKey()
    Data.i @SetOnlineScoreURL()
    Data.i @CreateScoreFile()
    Data.i @ReadScoreFile()
    Data.i @InsertQualifiedOfflinePlayerScore()
    Data.i @InsertQualifiedOnlinePlayerScore()
    Data.i @ExamineOnlineScore()
    Data.i @AddOnlineScoreItem()
    Data.i @ResetOfflineSprint()
    Data.i @NextOfflineSprint()
    Data.i @ResetOfflineEndurance()
    Data.i @NextOfflineEndurance()
    Data.i @ResetOnlineSprint()
    Data.i @NextOnlineSprint()
    Data.i @ResetOnlineEndurance()
    Data.i @NextOnlineEndurance()
    Data.i @Free()
    END_METHODS:
  EndDataSection

EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (199000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.71 beta 1 LTS (Linux - x64)
; Folding = PAAghBw-
; EnableXP
; CompileSourceDirectory