; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Object - V0.0.1
; Nom du projet : Le nom du projet ici
; Nom du fichier : Nom du fichier
; Version du fichier : 0.0.0
; Programmation :  vrifier
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 04-05-2019
; Mise  jour : 04-05-2019
; Cod pour PureBasic : V5.71 beta 1 LTS
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Window

  Interface Window
    
    GetHandle.i()
    GetCurrentPosition()
    GetCurrentSize()
    GetCurrentPositionSize()
    SetTitle(P_Title.s)
    SetBounds(P_MinWidth.l, P_MinHeight.l, P_MaxWidth.l = #PB_Ignore, P_MaxHeight.l = #PB_Ignore)
    Open(Flag = #PB_Window_SystemMenu)
    OpenEx(P_Title.s, Flag = #PB_Window_SystemMenu, ParentID.i = #Null)
    ReadPrefs(GroupName.s)
    WritePrefs(GroupName.s)
    Width.l()
    Height.l()
    SanityCheck()
    Reshape()
    Free()

  EndInterface

  Declare.i New(P_PosX.l, P_PosY.l, P_Width.l, P_Height.l, P_SizeFlag.b = #True)

EndDeclareModule

Module Window

  Structure Private_Members

    VirtualTable.i
    Handle.i
    PosX.l
    PosY.l
    Width.l
    Height.l
    SizeFlag.b
    BoundsFlag.l
    MinWidth.l
    MinHeight.l
    MaxWidth.l
    MaxHeight.l
  
  EndStructure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les Observateurs <<<<<
  
  Procedure GetHandle(*This.Private_Members)
  
    ProcedureReturn *This\Handle
  EndProcedure
  
  Procedure GetCurrentPosition(*This.Private_Members)
    
    *This\PosX = WindowX(*This\Handle)
    *This\PosY = WindowY(*This\Handle)
    
  EndProcedure
  
  Procedure GetCurrentSize(*This.Private_Members)
    
    *This\Width = WindowWidth(*This\Handle)
    *This\Height = WindowHeight(*This\Handle)
    
  EndProcedure
  
  Procedure GetCurrentPositionSize(*This.Private_Members)
    
    *This\PosX = WindowX(*This\Handle)
    *This\PosY = WindowY(*This\Handle)
    *This\Width = WindowWidth(*This\Handle)
    *This\Height = WindowHeight(*This\Handle)
    
  EndProcedure
  
  Procedure SetTitle(*This.Private_Members, P_Title.s)
    
    SetWindowTitle(*This\Handle, P_Title)
   
  EndProcedure
  
  Procedure SetBounds(*This.Private_Members, P_MinWidth.l, P_MinHeight.l, P_MaxWidth.l = #PB_Ignore, P_MaxHeight.l = #PB_Ignore)
    
    *This\BoundsFlag = #True
    *This\MinWidth = P_MinWidth
    *This\MinHeight = P_MinHeight
    *This\MaxWidth = P_MaxWidth
    *This\MaxHeight = P_MaxHeight
    
  EndProcedure
  
  Procedure Open(*This.Private_Members, Flag = #PB_Window_SystemMenu)
    
    *This\Handle = OpenWindow(#PB_Any, *This\PosX, *This\PosY, *This\Width, *This\Height, "", Flag)
    
    If *This\BoundsFlag = #True
      WindowBounds(*This\Handle, *This\MinWidth, *This\MinHeight, *This\MaxWidth, *This\MaxHeight)
    EndIf
    
    ProcedureReturn *This\Handle
  EndProcedure
  
  Procedure OpenEx(*This.Private_Members, P_Title.s, Flag = #PB_Window_SystemMenu, ParentID.i = #Null)
    
    *This\Handle = OpenWindow(#PB_Any, *This\PosX, *This\PosY, *This\Width, *This\Height, P_Title, Flag, ParentID)
    
    If *This\BoundsFlag = #True
      WindowBounds(*This\Handle, *This\MinWidth, *This\MinHeight, *This\MaxWidth, *This\MaxHeight)
    EndIf
    
    ProcedureReturn *This\Handle
  EndProcedure
  
  Procedure ReadPrefs(*This.Private_Members, GroupName.s)
    
    PreferenceGroup(GroupName)
    
    *This\PosX = ReadPreferenceLong("PosX", *This\PosX)
    *This\PosY = ReadPreferenceLong("PosY", *This\PosY)
    
    If *This\SizeFlag = #True
      *This\Width = ReadPreferenceLong("Width", *This\Width)
      *This\Height = ReadPreferenceLong("Height", *This\Height)
    EndIf
    
    If *This\BoundsFlag = #True
      
      If *This\MinWidth <> #PB_Ignore 
        *This\MinWidth = ReadPreferenceLong("MinWidth", *This\MinWidth)
      EndIf
      
      If *This\MinHeight <> #PB_Ignore 
        *This\MinHeight = ReadPreferenceLong("MinHeight", *This\MinHeight)
      EndIf
      
      If *This\MaxWidth <> #PB_Ignore 
        *This\MaxWidth = ReadPreferenceLong("MaxWidth", *This\MaxWidth)
      EndIf
      
      If *This\MaxHeight <> #PB_Ignore 
        *This\MaxHeight = ReadPreferenceLong("MaxHeight", *This\MaxHeight)
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure WritePrefs(*This.Private_Members, GroupName.s)
    
    PreferenceGroup(GroupName)
    
    WritePreferenceLong("PosX", *This\PosX)
    WritePreferenceLong("PosY", *This\PosY)
    
    If *This\SizeFlag = #True
      WritePreferenceLong("Width", *This\Width)
      WritePreferenceLong("Height", *This\Height)
    EndIf
    
    If *This\BoundsFlag = #True
      
      If *This\MinWidth <> #PB_Ignore 
        WritePreferenceLong("MinWidth", *This\MinWidth)
      EndIf
      
      If *This\MinHeight <> #PB_Ignore 
        WritePreferenceLong("MinHeight", *This\MinHeight)
      EndIf
      
      If *This\MaxWidth <> #PB_Ignore 
        WritePreferenceLong("MaxWidth", *This\MaxWidth)
      EndIf
      
      If *This\MaxHeight <> #PB_Ignore 
        WritePreferenceLong("MaxHeight", *This\MaxHeight)
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure.l Width(*This.Private_Members)
    
    ProcedureReturn *This\Width
  EndProcedure
  
  Procedure.l Height(*This.Private_Members)
    
    ProcedureReturn *This\Height
  EndProcedure
  
  Procedure SanityCheck(*This.Private_Members)
    
    If ExamineDesktops()
      
      If *This\PosX > DesktopWidth(0) Or *This\PosX < 0
        *This\PosX = 50
      EndIf
      
      If *This\PosY > DesktopHeight(0) Or *This\PosY < 0
        *This\PosY = 50
      EndIf
      
      If (*This\PosX + *This\Width) > DesktopWidth(0)
        *This\PosX = *This\PosX - *This\Width
      EndIf
      
      If (*This\PosY + *This\Height) > DesktopHeight(0)
        *This\PosY = *This\PosY - *This\Height
      EndIf
      
      If *This\SizeFlag = #True
        
        If *This\Width > DesktopWidth(0)
          *This\Width = DesktopWidth(0) - *This\PosX
        EndIf
        
        If *This\Height > DesktopHeight(0)
          *This\Height = DesktopHeight(0) - *This\PosY
        EndIf 
        
      EndIf
      
    Else 
      
      *This\PosX = 50
      *This\PosY = 50
      
    EndIf
    
  EndProcedure
  
  Procedure Reshape(*This.Private_Members)
    
    ResizeWindow(*This\Handle, *This\PosX, *This\PosY, *This\Width, *This\Height)
    
  EndProcedure 
  
  Procedure Free(*This.Private_Members)

    ClearStructure(*This, Private_Members)
    FreeStructure(*This)

  EndProcedure

  Procedure.i New(P_PosX.l, P_PosY.l, P_Width.l, P_Height.l, P_SizeFlag.b = #True)

    *This.Private_Members = AllocateStructure(Private_Members)
    *This\VirtualTable = ?START_METHODS
    
    *This\PosX = P_PosX
    *This\PosY = P_PosY
    *This\Width = P_Width
    *This\Height = P_Height
    *This\SizeFlag = P_SizeFlag
    
    *This\BoundsFlag = #False
    *This\MinWidth = #PB_Ignore
    *This\MinHeight = #PB_Ignore
    *This\MaxWidth = #PB_Ignore
    *This\MaxHeight = #PB_Ignore
    
    ProcedureReturn *This
  EndProcedure

  DataSection
    START_METHODS:
    Data.i @GetHandle()
    Data.i @GetCurrentPosition()
    Data.i @GetCurrentSize()
    Data.i @GetCurrentPositionSize()
    Data.i @SetTitle()
    Data.i @SetBounds()
    Data.i @Open()
    Data.i @OpenEx()
    Data.i @ReadPrefs()
    Data.i @WritePrefs()
    Data.i @Width()
    Data.i @Height()
    Data.i @SanityCheck()
    Data.i @Reshape()
    Data.i @Free()
    END_METHODS:
  EndDataSection

EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (82000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.71 beta 1 LTS (Linux - x64)
; Folding = Pgg9
; EnableXP
; CompileSourceDirectory